<template>
  <section id="game">
    <div class="question-card" v-if="currentQuestion != []">
      <h4>Question {{ index }}</h4>
      <h2 v-html="currentQuestion.question"></h2>
      <section class="answer-block">
        <div
          v-for="answer of currentAnswers"
          :key="answer"
          @click="checkAnswer(answer)"
        >
          <GameCard v-html="answer"></GameCard>
        </div>
      </section>
    </div>
  </section>
</template>

<script lang="ts">
import Vue from "vue";
import { Question } from "@/interfaces/question";
import { shuffleAnswers } from "@/utils/util";
import GameCard from "@/components/GameCard.vue";
import store from "@/store";

export default Vue.extend({
  components: {
    GameCard
  },
  data() {
    return {
      questions: [],
      currentQuestion: {} as Question,
      index: 0,
      currentAnswers: [] as string[],
      score: 0,
      correctAnswers: [],
      wrongAnswers: []
    };
  },
  methods: {
    showNewQuestion() {
      if (this.index >= this.questions.length) {
        this.showScoreScreen();
        return;
      }
      this.currentQuestion = this.questions[this.index];
      if (["True", "False"].includes(this.currentQuestion.correctAnswer)) {
        this.currentAnswers = ["True", "False"];
      } else {
        this.currentAnswers = shuffleAnswers(this.currentQuestion);
      }

      this.index++;
    },

    checkAnswer(answer: string) {
      if (answer == this.currentQuestion.correctAnswer) {
        const correctResults = [
          this.currentQuestion.question,
          this.currentQuestion.correctAnswer
        ];
        this.$store.commit("setCorrectResults", correctResults);
        this.$store.commit("incrementScore");
        this.showNewQuestion();
      } else {
        const wrongResults = [
          this.currentQuestion.question,
          this.currentQuestion.correctAnswer,
          answer
        ];
        this.$store.commit("setWrongResults", wrongResults);
        this.showNewQuestion();
      }
    },
    showScoreScreen() {
      this.$router.push("/score");
    }
  },
  async created() {
    this.questions = store.getters.getQuestions;
    this.showNewQuestion();
  }
});
</script>

<style>
#question {
  background: #aebfb7;
  padding: 50px;
}

.question-card {
  background: #aebfb7;
  text-align: center;
  border-radius: 22px;
  align-items: center;
  justify-content: center;
  padding: 2em;
  width: 50vw;
}

.answer-block {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
  flex-wrap: wrap;
}

#game {
  display: flex;
  align-items: center;
  justify-content: center;
}
</style>
